/*
******************************************************************************

   Edemo extension internals

   Authors:	1999 Marcus Sundberg	[marcus@ggi-project.org]
  
   This code is placed in the public domain and may be used freely for any
   purpose.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _GGI_EDEMO_INT_H
#define _GGI_EDEMO_INT_H

#include <ggi/internal/internal.h>
#include "edemo.h"

__BEGIN_DECLS

/* Exported variables */
#ifdef BUILDING_LIBEDEMO
extern ggi_extid    _edemoID;
#else
IMPORTVAR ggi_extid _edemoID;
#endif

__END_DECLS

/* Data types for the API functions */
typedef int (edemofunc_function1)(ggi_visual *vis, int arg1);
typedef int (edemofunc_function2)(ggi_visual *vis, int arg1, int arg2);

typedef struct edemopriv {
	edemofunc_function1  *function1; /* Ponter to an API function */
	edemofunc_function2  *function2; /* Ponter to another API function */
	void *priv;	/* Here sublibs can store visual specific private data.
			   If you have more than one sublib (for each visual)
			   that needs private data, just add more pointers or
			   add the data fields directly in this structure. */
} edemopriv;

/* Used to access the edemopriv structure for a particular visual. */
#define LIBGGI_EDEMOEXT(vis) ((edemopriv *)LIBGGI_EXT((vis),_edemoID))

#endif /* _GGI_EDEMO_INT_H */
